<?php

namespace Drupal\storychief\Plugin\StoryChiefFieldHandler;

use Drupal\storychief\Plugin\FieldHandlerType\TaxonomyTermFieldHandlerType;

/**
 * Class CategoriesTaxonomyTermStoryChiefFieldHandler.
 *
 * Set the tags as taxonomy terms.
 *
 * @StoryChiefFieldHandler(
 *   id = "category",
 *   label = @Translation("Handle the categories."),
 *   drupal_field_name = null,
 * )
 *
 */
class CategoriesStoryChiefFieldHandler extends TaxonomyTermFieldHandlerType
{

  public function setValue($value)
  {
    // TODO: migrate legacy field ID category to categories meaning we need to migrate the config mapping from field_category to field_categories too
    $term_names = array_column($this->getPayload()['categories']['data'], 'name');
    parent::setValue($term_names);
  }
}
