<?php

namespace Drupal\storychief\Plugin\StoryChiefFieldHandler;

use Drupal\storychief\Plugin\FieldHandlerType\ImageFieldHandlerType;

/**
 * Class FeaturedImageStoryChiefFieldHandler.
 *
 * Set the featured image and alt text.
 *
 * @StoryChiefFieldHandler(
 *   id = "featured_image",
 *   label = @Translation("Handle the featured image field."),
 *   drupal_field_name = null,
 * )
 */
class FeaturedImageStoryChiefFieldHandler extends ImageFieldHandlerType
{

  public function setValue($value)
  {
    parent::setValue($value['data']['sizes']['full']);
  }

  public function set()
  {
    parent::set(); // TODO: Change the autogenerated stub

    $alt = $this->getPayload()['featured_image']['data']['alt'] ?? $this->getPayload()['title'];
    $this->getEntity()->get($this->getDrupalFieldName())[0]->set('alt', $alt);
  }
}
